//+------------------------------------------------------------------+
//|                                               forexavengerea.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double lots=0.01;
extern double tp=30;
extern double sl=50;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int total,i,ticket, opentijd;
   double ema1, ema2, williams1, williams2,  highopen, highsl, lowopen,lowsl;
   
   total = OrdersTotal();
   ema1 = iMA(Symbol(),0,40,0,MODE_EMA,PRICE_CLOSE,1);
   ema2 = iMA(Symbol(),0,80,0,MODE_EMA,PRICE_CLOSE,1);
   highopen = High[1];
   lowopen = Low[1];
   williams1 = iWPR(Symbol(),0,21,1);
   williams2 = iWPR(Symbol(),0,21,2);
   highsl = 0;
   lowsl = 5;
      

   for(i=1;i<7;i++)
   {
      if(High[i] > highsl) highsl = High[i];
      if(Low[i] < lowsl) lowsl = Low[i];
   }
   
   if(highsl-highopen > sl) highsl = sl;
   if(lowopen-lowsl > sl) lowsl = sl;
   
   if(total ==1)
   {
      OrderSelect(ticket, SELECT_BY_POS);
      
      if(OrderType() == OP_BUYSTOP && TimeHour(TimeCurrent())-opentijd>0)
      {
         if(williams1 >-80)
         {
            OrderModify(OrderTicket(),highopen+2*Point,OrderStopLoss(),highopen+(tp+2)*Point,0,CLR_NONE);
         }
         if(williams1<-80)
         {
            OrderDelete(OrderTicket());
         }
      }
      
      if(OrderType() == OP_SELLSTOP && TimeHour(TimeCurrent())-opentijd>0)
      {
         if(williams1<-20)
         {
            OrderModify(OrderTicket(),lowopen-2*Point,OrderStopLoss(),lowopen-(tp+2)*Point,0,CLR_NONE);
         }
         
         if(williams1>-20)
         {
            OrderDelete(OrderTicket());
         }
      }
   }
   
   if(total == 0)
   {
      if(ema1>ema2) //buy
      {
         if(williams1 > -80 && williams2 < -80)
         {
            Alert("buy order");
            ticket=OrderSend(Symbol(),OP_BUYSTOP,lots,highopen+2*Point,10,highsl+5*Point,highopen+(tp+2)*Point,0,0,0,CLR_NONE);
            if(ticket<0)
            {
                Print("OrderSend failed with error #",GetLastError());
                return(0);
            }
            opentijd = TimeHour(TimeCurrent());
         }
      }
      
      if(ema1<ema2)//sell
      {
         if(williams1 < -20 && williams2 > -20)
         {
            Alert("sell order");
            ticket= OrderSend(Symbol(),OP_SELLSTOP,lots,lowopen-2*Point,10,lowsl-5*Point,lowopen-(tp+2)*Point,0,0,0,CLR_NONE);
            if(ticket<0)
            {
                Print("OrderSend failed with error #",GetLastError());
                return(0);
            }
            opentijd = TimeHour(TimeCurrent());
         }
      
      }
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+